class BootState extends RootState{
    constructor(){
        super();
    }
    init(){
        this.mainInit();
        this.groups =[];
        this.preloadBar = {
            graphic : null,
            height : 32,
            width : 347,
        }
        this.preloadText = null;
        this.preloadSecondText = null; 
        this.isLoaded= false;
        this.startTime = new Date();
    }
    preload() {
        let that = this;
        
        ///Начало загрузки:
        //this.load.image('background6','/asstes/img/gui/background6.png');
        let mainUI = this.GUI.addUI(0,0,this.game.width,this.game.height,null,1,10);
        mainUI.addBackground(0,'bg_2',1,false);
        //let bg = mainUI.addCastomSizeBackground(0,1800,1000,'bg_2',1,false)
        //mainUI.addBackground(0,'loadScreen',1,false);
        ///Создаем текст:
        //this.preloadText = mainUI.addBitMapText(3,true,(mainUI.width/2),(mainUI.height*0.8),'...Загрузка данных...','bit_bezpredmetizm_black',16,1,false);

        let hintText = mainUI.addText(4,true,(mainUI.width/2),(mainUI.height*0.75),ASSETS.getRandomLoadHint(),ASSETS.textStyles['commonLoad'],1,false);

        let label = mainUI.addImage(3,true,(mainUI.width/2),(mainUI.height/2),800/1.5,200/1.5,'label',1,false);
 
        //let hintText = mainUI.addTextWithStyle(4,true,(mainUI.width/2),(mainUI.height*0.95),ASSETS.getRandomLoadHint(),ASSETS.textStyles['common'],1,false);
  
        //hintText.anchor.setTo(0.5,0.5);
        //autoRound 
        let loadText = mainUI.addText(5,true,(mainUI.width/2),(mainUI.height*0.85+5),ASSETS.getText('text35',LANGUAGE),ASSETS.textStyles['commonDarkBlue'],1,false);
        //let loadText = mainUI.addTextWithStyle(4,true,(mainUI.width/2),(mainUI.height*0.85),ASSETS.getText('text35',LANGUAGE),ASSETS.textStyles['common'],1,false);
        //loadText.anchor.setTo(0.5,0.5);
        //loadText.x = Math.round(loadText.x-(loadText.width)/2);
        //loadText.y = Math.round(loadText.y-(loadText.height)/2);
        //loadText.anchor.setTo(0,0);
        //loadText.x = mainUI.x+Math.round(loadText.x/2);
        //loadText.y = mainUI.y+Math.round(loadText.y/2);
        ///Создаем бар
        this.preloadBar.graphic = game.add.graphics(0,0);
        let grath = this.game.add.graphics(0,0);
        //0x191970
        grath.beginFill(0x8B4513);
        //grath.lineStyle(3, 0xE5E110, 1);
        grath.drawRect((mainUI.width/2) - (this.preloadBar.width /2),(mainUI.height*0.85) - (this.preloadBar.height /2), this.preloadBar.width, this.preloadBar.height);
        grath.endFill();
        
        
        mainUI.getLayer(2,function(layer,inputPriority){
            layer.add(that.preloadBar.graphic);
        });
        mainUI.getLayer(1,function(layer,inputPriority){
            layer.add(grath);
        });
        
        this.game.load.onLoadStart.add(function(){
        }, this);
        
        function addRectLoadingBar(progress){
            //that.preloadText.setText(progress + "%");
            //000C2C#649DB7
            //0x1E90FF
            that.preloadBar.graphic.beginFill(0xFFD700);
            that.preloadBar.graphic.drawRect((mainUI.width/2) - (that.preloadBar.width /2),(mainUI.height*0.85) - (that.preloadBar.height /2),(progress / 100) * that.preloadBar.width,that.preloadBar.height);
            that.preloadBar.graphic.endFill();
        }
        //this.game.load.onFileComplete.add(this.fileComplete, this);
        this.game.load.onFileComplete.add(function(progress, cacheKey, success, totalLoaded, totalFiles){
            that.preloadBar.graphic.clear();
            addRectLoadingBar(progress)
        }, this);
        let bar =  mainUI.addImage(3,true,mainUI.width/2 ,mainUI.height*0.85, 355, 54,'ui_bar',1,false);
        
        this.preloadText = mainUI.addText(4,true,mainUI.width/2 ,mainUI.height*0.85,'',ASSETS.textStyles['commonGold'],1,false);
        //this.preloadText.x = Math.round(this.preloadText.x + (this.preloadText.width)/2);
        //this.preloadText.y = Math.round(this.preloadText.y + (this.preloadText.height)/2);
        //this.preloadText.anchor.setTo(0.5,0.5);  
        
        
        this.game.load.onLoadComplete.add(function(){
            //this.preloadText.destroy(true);
            //this.preloadBar.graphic.destroy(true);
            that.isLoaded = true;
        }, this);
        
        ///Загрузка ассетов
        for(let i in ASSETS.images){
            this.game.load.image(ASSETS.images[i].imageKey,ASSETS.images[i].path);
        }
        for(let i in ASSETS.spritesheets){
            this.game.load.spritesheet(ASSETS.spritesheets[i].imageKey,ASSETS.spritesheets[i].path,ASSETS.spritesheets[i].wSizeFrame,ASSETS.spritesheets[i].hSizeFrame);
        }
        for(let i in ASSETS.bitMapFonts){
            this.game.load.bitmapFont(ASSETS.bitMapFonts[i].key,ASSETS.bitMapFonts[i].pngPath,ASSETS.bitMapFonts[i].fntPath);
        }
        for(let i in ASSETS.audios){
            this.game.load.audio(ASSETS.audios[i].audioKey, ASSETS.audios[i].pathsArray);
        }
    }
    create(){
        this.mainCreate();
    }
    update(){
        this.mainUpdate();
        //this.checkLoadData();
        if((this.isLoaded) && ((new Date() - this.startTime ) >= 2000) && (KEEPER.dataIsLoad)){
            ///ПРОВЕРКА КАКУЮ СЦЕНУ ЗАГРУЖАТЬ: ЛОКАЦИЯ ИЛИ СОЗДАНИЕ ПЕРСОНАЖА
            KEEPER.isLoad = true;
            if(KEEPER.user.inBattle){
                
                if( (KEEPER.battle.info.status == 'set') || (KEEPER.battle.info.status =='prepeare') ){
                    console.log(KEEPER.battle.info.status)
                    game.state.start('LobbyState');
                }else if( (KEEPER.battle.info.status == 'play') || (KEEPER.battle.info.status =='end') ){
                    game.state.start('BattleState');
                }
            }else{
                game.state.start('LobbyState');
            }
 
            /*
            if(!KEEPER.hasPerson){
                game.state.start('CreateState');
            }
            */
        }
        
        /*
        if((KEEPER.loadedData.classes) && (KEEPER.loadedData.races)){
            KEEPER.allDataIsLoad = true;
        }
        */
            
         
    }
    /*
    checkLoadData(){
      let allCount = 0;
        let loadedCount = 0;
        for(let i in KEEPER.loadedData){
            if(KEEPER.loadedData[i].isLoad){
                loadedCount++;
            }
            allCount++;
        }
        if(allCount === loadedCount){
            KEEPER.allDataIsLoad = true;
        }  
    }
    */
    render(){
        this.mainRender()
    }
    
}